using System;
using System.Collections;
using System.Web.UI.WebControls;

using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.IsPostBack)
        {
            this.GetData();
        }
        else
        {
            this.BindGrid();
        }
    }

    private void BindGrid()
    {
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        string query = "SELECT * FROM Customers";
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
            {
                using (DataTable dt = new DataTable())
                {
                    sda.Fill(dt);
                    gvCustomers.DataSource = dt;
                    gvCustomers.DataBind();
                }
            }
        }
    }

    protected void OnPaging(object sender, GridViewPageEventArgs e)
    {
        gvCustomers.PageIndex = e.NewPageIndex;
        this.BindGrid();
        this.SetData();
    }

    private void GetData()
    {
        ArrayList arr = new ArrayList();
        if (ViewState["SelectedRecords"] != null)
        {
            arr = (ArrayList)ViewState["SelectedRecords"];
        }

        CheckBox chkAll = (CheckBox)gvCustomers.HeaderRow.Cells[0].FindControl("chkAll");
        foreach (GridViewRow row in gvCustomers.Rows)
        {
            if (chkAll.Checked)
            {
                if (!arr.Contains(gvCustomers.DataKeys[row.RowIndex].Value))
                {
                    arr.Add(gvCustomers.DataKeys[row.RowIndex].Value);
                }
            }
            else
            {
                CheckBox chk = (CheckBox)row.FindControl("chkRow");
                if (chk.Checked)
                {
                    if (!arr.Contains(gvCustomers.DataKeys[row.RowIndex].Value))
                    {
                        arr.Add(gvCustomers.DataKeys[row.RowIndex].Value);
                    }
                }
                else
                {
                    if (arr.Contains(gvCustomers.DataKeys[row.RowIndex].Value))
                    {
                        arr.Remove(gvCustomers.DataKeys[row.RowIndex].Value);
                    }
                }
            }
        }
        ViewState["SelectedRecords"] = arr;
    }

    private void SetData()
    {
        int currentCount = 0;
        CheckBox chkAll = (CheckBox)gvCustomers.HeaderRow.Cells[0].FindControl("chkAll");
        chkAll.Checked = true;
        ArrayList arr = (ArrayList)ViewState["SelectedRecords"];
        foreach (GridViewRow row in gvCustomers.Rows)
        {
            CheckBox chk = (CheckBox)row.FindControl("chkRow");
            if (chk != null)
            {
                chk.Checked = arr.Contains(gvCustomers.DataKeys[row.RowIndex].Value);
                if (!chk.Checked)
                {
                    chkAll.Checked = false;
                }
                else
                {
                    currentCount++;
                }
            }
        }
        hfCount.Value = (arr.Count - currentCount).ToString();
    }

    protected void Delete(object sender, EventArgs e)
    {
        int count = 0;
        this.BindGrid();
        this.SetData();
        gvCustomers.AllowPaging = false;
        gvCustomers.DataBind();
        ArrayList arr = (ArrayList)ViewState["SelectedRecords"];
        count = arr.Count;
        foreach (GridViewRow row in gvCustomers.Rows)
        {
            if (arr.Contains(gvCustomers.DataKeys[row.RowIndex].Value))
            {
                this.DeleteRecord(gvCustomers.DataKeys[row.RowIndex].Value.ToString());
                arr.Remove(gvCustomers.DataKeys[row.RowIndex].Value);
            }
        }
        ViewState["SelectedRecords"] = arr;
        hfCount.Value = "0";
        gvCustomers.AllowPaging = true;
        this.BindGrid();
        ClientScript.RegisterStartupScript(this.GetType(), "alert", "alert('" + count + " records deleted.');", true);
    }

    private void DeleteRecord(string customerId)
    {
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        string query = "DELETE FROM Customers WHERE CustomerId = @CustomerId";
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand(query, con))
            {
                cmd.Parameters.AddWithValue("@CustomerId", customerId);
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
            }
        }
    }
}