Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Partial Public Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Me.IsPostBack Then
            Me.GetData()
        Else
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Dim query As String = "SELECT * FROM Customers"
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                Using dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    gvCustomers.DataSource = dt
                    gvCustomers.DataBind()
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnPaging(ByVal sender As Object, ByVal e As GridViewPageEventArgs)
        gvCustomers.PageIndex = e.NewPageIndex
        Me.BindGrid()
        Me.SetData()
    End Sub

    Private Sub GetData()
        Dim arr As ArrayList = New ArrayList()
        If ViewState("SelectedRecords") IsNot Nothing Then
            arr = CType(ViewState("SelectedRecords"), ArrayList)
        End If
        Dim chkAll As CheckBox = CType(gvCustomers.HeaderRow.Cells(0).FindControl("chkAll"), CheckBox)
        For Each row As GridViewRow In gvCustomers.Rows
            If chkAll.Checked Then
                If Not arr.Contains(gvCustomers.DataKeys(row.RowIndex).Value) Then
                    arr.Add(gvCustomers.DataKeys(row.RowIndex).Value)
                End If
            Else
                Dim chk As CheckBox = CType(row.FindControl("chkRow"), CheckBox)
                If chk.Checked Then
                    If Not arr.Contains(gvCustomers.DataKeys(row.RowIndex).Value) Then
                        arr.Add(gvCustomers.DataKeys(row.RowIndex).Value)
                    End If
                Else
                    If arr.Contains(gvCustomers.DataKeys(row.RowIndex).Value) Then
                        arr.Remove(gvCustomers.DataKeys(row.RowIndex).Value)
                    End If
                End If
            End If
        Next
        ViewState("SelectedRecords") = arr
    End Sub

    Private Sub SetData()
        Dim currentCount As Integer = 0
        Dim chkAll As CheckBox = CType(gvCustomers.HeaderRow.Cells(0).FindControl("chkAll"), CheckBox)
        chkAll.Checked = True
        Dim arr As ArrayList = CType(ViewState("SelectedRecords"), ArrayList)
        For Each row As GridViewRow In gvCustomers.Rows
            Dim chk As CheckBox = CType(row.FindControl("chkRow"), CheckBox)
            If chk IsNot Nothing Then
                chk.Checked = arr.Contains(gvCustomers.DataKeys(row.RowIndex).Value)
                If Not chk.Checked Then
                    chkAll.Checked = False
                Else
                    currentCount += 1
                End If
            End If
        Next
        hfCount.Value = (arr.Count - currentCount).ToString()
    End Sub

    Protected Sub Delete(ByVal sender As Object, ByVal e As EventArgs)
        Dim count As Integer = 0
        Me.BindGrid()
        Me.SetData()
        gvCustomers.AllowPaging = False
        gvCustomers.DataBind()
        Dim arr As ArrayList = CType(ViewState("SelectedRecords"), ArrayList)
        count = arr.Count
        For Each row As GridViewRow In gvCustomers.Rows
            If arr.Contains(gvCustomers.DataKeys(row.RowIndex).Value) Then
                Me.DeleteRecord(gvCustomers.DataKeys(row.RowIndex).Value.ToString())
                arr.Remove(gvCustomers.DataKeys(row.RowIndex).Value)
            End If
        Next
        ViewState("SelectedRecords") = arr
        hfCount.Value = "0"
        gvCustomers.AllowPaging = True
        Me.BindGrid()
        ClientScript.RegisterStartupScript(Me.[GetType](), "alert", "alert('" & count & " records deleted.');", True)
    End Sub

    Private Sub DeleteRecord(ByVal customerId As String)
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Dim query As String = "DELETE FROM Customers WHERE CustomerId = @CustomerId"
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query, con)
                cmd.Parameters.AddWithValue("@CustomerId", customerId)
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
            End Using
        End Using
    End Sub
End Class

